"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const updateSocketData = (originalData, newData) => {
    try {
        const copyOriginal = (0, lodash_1.cloneDeep)(originalData);
        const copyNew = (0, lodash_1.cloneDeep)(newData);
        if (!copyOriginal.length || !copyNew.length) {
            return copyOriginal || copyNew;
        }
        const copyOriginalIndexed = copyOriginal.reduce((acc, curr) => (Object.assign(Object.assign({}, acc), { [curr.code]: curr })), // curr을 통해 copyOriginal 원소의 reference를 넘김
        {});
        copyNew.forEach(ele => {
            const target = copyOriginalIndexed[ele.code];
            if (target) {
                Object.assign(target, ele); // copyOriginal 원소의 reference인 target을 Object.assign하여 덮어씌움으로 copyOriginal까지 변경
            }
            else {
                copyOriginal.push(ele);
            }
        });
        return copyOriginal;
    }
    catch (error) {
        console.error(error);
        return originalData;
    }
};
exports.default = updateSocketData;
